package com.idea.customerManagement.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CustomerManagementExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CustomerManagementExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andGroupIdIsNull() {
            addCriterion("group_id is null");
            return (Criteria) this;
        }

        public Criteria andGroupIdIsNotNull() {
            addCriterion("group_id is not null");
            return (Criteria) this;
        }

        public Criteria andGroupIdEqualTo(String value) {
            addCriterion("group_id =", value, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdNotEqualTo(String value) {
            addCriterion("group_id <>", value, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdGreaterThan(String value) {
            addCriterion("group_id >", value, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdGreaterThanOrEqualTo(String value) {
            addCriterion("group_id >=", value, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdLessThan(String value) {
            addCriterion("group_id <", value, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdLessThanOrEqualTo(String value) {
            addCriterion("group_id <=", value, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdLike(String value) {
            addCriterion("group_id like", value, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdNotLike(String value) {
            addCriterion("group_id not like", value, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdIn(List<String> values) {
            addCriterion("group_id in", values, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdNotIn(List<String> values) {
            addCriterion("group_id not in", values, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdBetween(String value1, String value2) {
            addCriterion("group_id between", value1, value2, "groupId");
            return (Criteria) this;
        }

        public Criteria andGroupIdNotBetween(String value1, String value2) {
            addCriterion("group_id not between", value1, value2, "groupId");
            return (Criteria) this;
        }

        public Criteria andDiscIdIsNull() {
            addCriterion("disc_id is null");
            return (Criteria) this;
        }

        public Criteria andDiscIdIsNotNull() {
            addCriterion("disc_id is not null");
            return (Criteria) this;
        }

        public Criteria andDiscIdEqualTo(String value) {
            addCriterion("disc_id =", value, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdNotEqualTo(String value) {
            addCriterion("disc_id <>", value, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdGreaterThan(String value) {
            addCriterion("disc_id >", value, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdGreaterThanOrEqualTo(String value) {
            addCriterion("disc_id >=", value, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdLessThan(String value) {
            addCriterion("disc_id <", value, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdLessThanOrEqualTo(String value) {
            addCriterion("disc_id <=", value, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdLike(String value) {
            addCriterion("disc_id like", value, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdNotLike(String value) {
            addCriterion("disc_id not like", value, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdIn(List<String> values) {
            addCriterion("disc_id in", values, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdNotIn(List<String> values) {
            addCriterion("disc_id not in", values, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdBetween(String value1, String value2) {
            addCriterion("disc_id between", value1, value2, "discId");
            return (Criteria) this;
        }

        public Criteria andDiscIdNotBetween(String value1, String value2) {
            addCriterion("disc_id not between", value1, value2, "discId");
            return (Criteria) this;
        }

        public Criteria andBatchNumberIsNull() {
            addCriterion("batch_number is null");
            return (Criteria) this;
        }

        public Criteria andBatchNumberIsNotNull() {
            addCriterion("batch_number is not null");
            return (Criteria) this;
        }

        public Criteria andBatchNumberEqualTo(String value) {
            addCriterion("batch_number =", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberNotEqualTo(String value) {
            addCriterion("batch_number <>", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberGreaterThan(String value) {
            addCriterion("batch_number >", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberGreaterThanOrEqualTo(String value) {
            addCriterion("batch_number >=", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberLessThan(String value) {
            addCriterion("batch_number <", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberLessThanOrEqualTo(String value) {
            addCriterion("batch_number <=", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberLike(String value) {
            addCriterion("batch_number like", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberNotLike(String value) {
            addCriterion("batch_number not like", value, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberIn(List<String> values) {
            addCriterion("batch_number in", values, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberNotIn(List<String> values) {
            addCriterion("batch_number not in", values, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberBetween(String value1, String value2) {
            addCriterion("batch_number between", value1, value2, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andBatchNumberNotBetween(String value1, String value2) {
            addCriterion("batch_number not between", value1, value2, "batchNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberIsNull() {
            addCriterion("room_selection_number is null");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberIsNotNull() {
            addCriterion("room_selection_number is not null");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberEqualTo(String value) {
            addCriterion("room_selection_number =", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberNotEqualTo(String value) {
            addCriterion("room_selection_number <>", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberGreaterThan(String value) {
            addCriterion("room_selection_number >", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberGreaterThanOrEqualTo(String value) {
            addCriterion("room_selection_number >=", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberLessThan(String value) {
            addCriterion("room_selection_number <", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberLessThanOrEqualTo(String value) {
            addCriterion("room_selection_number <=", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberLike(String value) {
            addCriterion("room_selection_number like", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberNotLike(String value) {
            addCriterion("room_selection_number not like", value, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberIn(List<String> values) {
            addCriterion("room_selection_number in", values, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberNotIn(List<String> values) {
            addCriterion("room_selection_number not in", values, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberBetween(String value1, String value2) {
            addCriterion("room_selection_number between", value1, value2, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionNumberNotBetween(String value1, String value2) {
            addCriterion("room_selection_number not between", value1, value2, "roomSelectionNumber");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateIsNull() {
            addCriterion("room_selection_date is null");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateIsNotNull() {
            addCriterion("room_selection_date is not null");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateEqualTo(Date value) {
            addCriterion("room_selection_date =", value, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateNotEqualTo(Date value) {
            addCriterion("room_selection_date <>", value, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateGreaterThan(Date value) {
            addCriterion("room_selection_date >", value, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateGreaterThanOrEqualTo(Date value) {
            addCriterion("room_selection_date >=", value, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateLessThan(Date value) {
            addCriterion("room_selection_date <", value, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateLessThanOrEqualTo(Date value) {
            addCriterion("room_selection_date <=", value, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateIn(List<Date> values) {
            addCriterion("room_selection_date in", values, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateNotIn(List<Date> values) {
            addCriterion("room_selection_date not in", values, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateBetween(Date value1, Date value2) {
            addCriterion("room_selection_date between", value1, value2, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andRoomSelectionDateNotBetween(Date value1, Date value2) {
            addCriterion("room_selection_date not between", value1, value2, "roomSelectionDate");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("status is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("status is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("status =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("status <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("status >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("status >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("status <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("status <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("status in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("status not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("status between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("status not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andHouseIdIsNull() {
            addCriterion("house_id is null");
            return (Criteria) this;
        }

        public Criteria andHouseIdIsNotNull() {
            addCriterion("house_id is not null");
            return (Criteria) this;
        }

        public Criteria andHouseIdEqualTo(String value) {
            addCriterion("house_id =", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotEqualTo(String value) {
            addCriterion("house_id <>", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdGreaterThan(String value) {
            addCriterion("house_id >", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdGreaterThanOrEqualTo(String value) {
            addCriterion("house_id >=", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdLessThan(String value) {
            addCriterion("house_id <", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdLessThanOrEqualTo(String value) {
            addCriterion("house_id <=", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdLike(String value) {
            addCriterion("house_id like", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotLike(String value) {
            addCriterion("house_id not like", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdIn(List<String> values) {
            addCriterion("house_id in", values, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotIn(List<String> values) {
            addCriterion("house_id not in", values, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdBetween(String value1, String value2) {
            addCriterion("house_id between", value1, value2, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotBetween(String value1, String value2) {
            addCriterion("house_id not between", value1, value2, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseNameIsNull() {
            addCriterion("house_name is null");
            return (Criteria) this;
        }

        public Criteria andHouseNameIsNotNull() {
            addCriterion("house_name is not null");
            return (Criteria) this;
        }

        public Criteria andHouseNameEqualTo(String value) {
            addCriterion("house_name =", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameNotEqualTo(String value) {
            addCriterion("house_name <>", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameGreaterThan(String value) {
            addCriterion("house_name >", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameGreaterThanOrEqualTo(String value) {
            addCriterion("house_name >=", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameLessThan(String value) {
            addCriterion("house_name <", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameLessThanOrEqualTo(String value) {
            addCriterion("house_name <=", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameLike(String value) {
            addCriterion("house_name like", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameNotLike(String value) {
            addCriterion("house_name not like", value, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameIn(List<String> values) {
            addCriterion("house_name in", values, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameNotIn(List<String> values) {
            addCriterion("house_name not in", values, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameBetween(String value1, String value2) {
            addCriterion("house_name between", value1, value2, "houseName");
            return (Criteria) this;
        }

        public Criteria andHouseNameNotBetween(String value1, String value2) {
            addCriterion("house_name not between", value1, value2, "houseName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameIsNull() {
            addCriterion("buyer_name is null");
            return (Criteria) this;
        }

        public Criteria andBuyerNameIsNotNull() {
            addCriterion("buyer_name is not null");
            return (Criteria) this;
        }

        public Criteria andBuyerNameEqualTo(String value) {
            addCriterion("buyer_name =", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameNotEqualTo(String value) {
            addCriterion("buyer_name <>", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameGreaterThan(String value) {
            addCriterion("buyer_name >", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameGreaterThanOrEqualTo(String value) {
            addCriterion("buyer_name >=", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameLessThan(String value) {
            addCriterion("buyer_name <", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameLessThanOrEqualTo(String value) {
            addCriterion("buyer_name <=", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameLike(String value) {
            addCriterion("buyer_name like", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameNotLike(String value) {
            addCriterion("buyer_name not like", value, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameIn(List<String> values) {
            addCriterion("buyer_name in", values, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameNotIn(List<String> values) {
            addCriterion("buyer_name not in", values, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameBetween(String value1, String value2) {
            addCriterion("buyer_name between", value1, value2, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerNameNotBetween(String value1, String value2) {
            addCriterion("buyer_name not between", value1, value2, "buyerName");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardIsNull() {
            addCriterion("buyer_identity_card is null");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardIsNotNull() {
            addCriterion("buyer_identity_card is not null");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardEqualTo(String value) {
            addCriterion("buyer_identity_card =", value, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardNotEqualTo(String value) {
            addCriterion("buyer_identity_card <>", value, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardGreaterThan(String value) {
            addCriterion("buyer_identity_card >", value, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardGreaterThanOrEqualTo(String value) {
            addCriterion("buyer_identity_card >=", value, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardLessThan(String value) {
            addCriterion("buyer_identity_card <", value, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardLessThanOrEqualTo(String value) {
            addCriterion("buyer_identity_card <=", value, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardLike(String value) {
            addCriterion("buyer_identity_card like", value, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardNotLike(String value) {
            addCriterion("buyer_identity_card not like", value, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardIn(List<String> values) {
            addCriterion("buyer_identity_card in", values, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardNotIn(List<String> values) {
            addCriterion("buyer_identity_card not in", values, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardBetween(String value1, String value2) {
            addCriterion("buyer_identity_card between", value1, value2, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andBuyerIdentityCardNotBetween(String value1, String value2) {
            addCriterion("buyer_identity_card not between", value1, value2, "buyerIdentityCard");
            return (Criteria) this;
        }

        public Criteria andCreatedIdIsNull() {
            addCriterion("created_id is null");
            return (Criteria) this;
        }

        public Criteria andCreatedIdIsNotNull() {
            addCriterion("created_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedIdEqualTo(String value) {
            addCriterion("created_id =", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdNotEqualTo(String value) {
            addCriterion("created_id <>", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdGreaterThan(String value) {
            addCriterion("created_id >", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdGreaterThanOrEqualTo(String value) {
            addCriterion("created_id >=", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdLessThan(String value) {
            addCriterion("created_id <", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdLessThanOrEqualTo(String value) {
            addCriterion("created_id <=", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdLike(String value) {
            addCriterion("created_id like", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdNotLike(String value) {
            addCriterion("created_id not like", value, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdIn(List<String> values) {
            addCriterion("created_id in", values, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdNotIn(List<String> values) {
            addCriterion("created_id not in", values, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdBetween(String value1, String value2) {
            addCriterion("created_id between", value1, value2, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedIdNotBetween(String value1, String value2) {
            addCriterion("created_id not between", value1, value2, "createdId");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNull() {
            addCriterion("updated_at is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIsNotNull() {
            addCriterion("updated_at is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtEqualTo(Date value) {
            addCriterion("updated_at =", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotEqualTo(Date value) {
            addCriterion("updated_at <>", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThan(Date value) {
            addCriterion("updated_at >", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("updated_at >=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThan(Date value) {
            addCriterion("updated_at <", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtLessThanOrEqualTo(Date value) {
            addCriterion("updated_at <=", value, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtIn(List<Date> values) {
            addCriterion("updated_at in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotIn(List<Date> values) {
            addCriterion("updated_at not in", values, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtBetween(Date value1, Date value2) {
            addCriterion("updated_at between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedAtNotBetween(Date value1, Date value2) {
            addCriterion("updated_at not between", value1, value2, "updatedAt");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdIsNull() {
            addCriterion("updated_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdIsNotNull() {
            addCriterion("updated_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdEqualTo(String value) {
            addCriterion("updated_id =", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdNotEqualTo(String value) {
            addCriterion("updated_id <>", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdGreaterThan(String value) {
            addCriterion("updated_id >", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdGreaterThanOrEqualTo(String value) {
            addCriterion("updated_id >=", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdLessThan(String value) {
            addCriterion("updated_id <", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdLessThanOrEqualTo(String value) {
            addCriterion("updated_id <=", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdLike(String value) {
            addCriterion("updated_id like", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdNotLike(String value) {
            addCriterion("updated_id not like", value, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdIn(List<String> values) {
            addCriterion("updated_id in", values, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdNotIn(List<String> values) {
            addCriterion("updated_id not in", values, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdBetween(String value1, String value2) {
            addCriterion("updated_id between", value1, value2, "updatedId");
            return (Criteria) this;
        }

        public Criteria andUpdatedIdNotBetween(String value1, String value2) {
            addCriterion("updated_id not between", value1, value2, "updatedId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateIsNull() {
            addCriterion("abandonment_date is null");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateIsNotNull() {
            addCriterion("abandonment_date is not null");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateEqualTo(Date value) {
            addCriterion("abandonment_date =", value, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateNotEqualTo(Date value) {
            addCriterion("abandonment_date <>", value, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateGreaterThan(Date value) {
            addCriterion("abandonment_date >", value, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateGreaterThanOrEqualTo(Date value) {
            addCriterion("abandonment_date >=", value, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateLessThan(Date value) {
            addCriterion("abandonment_date <", value, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateLessThanOrEqualTo(Date value) {
            addCriterion("abandonment_date <=", value, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateIn(List<Date> values) {
            addCriterion("abandonment_date in", values, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateNotIn(List<Date> values) {
            addCriterion("abandonment_date not in", values, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateBetween(Date value1, Date value2) {
            addCriterion("abandonment_date between", value1, value2, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentDateNotBetween(Date value1, Date value2) {
            addCriterion("abandonment_date not between", value1, value2, "abandonmentDate");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtIsNull() {
            addCriterion("abandonment_at is null");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtIsNotNull() {
            addCriterion("abandonment_at is not null");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtEqualTo(Date value) {
            addCriterion("abandonment_at =", value, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtNotEqualTo(Date value) {
            addCriterion("abandonment_at <>", value, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtGreaterThan(Date value) {
            addCriterion("abandonment_at >", value, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtGreaterThanOrEqualTo(Date value) {
            addCriterion("abandonment_at >=", value, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtLessThan(Date value) {
            addCriterion("abandonment_at <", value, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtLessThanOrEqualTo(Date value) {
            addCriterion("abandonment_at <=", value, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtIn(List<Date> values) {
            addCriterion("abandonment_at in", values, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtNotIn(List<Date> values) {
            addCriterion("abandonment_at not in", values, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtBetween(Date value1, Date value2) {
            addCriterion("abandonment_at between", value1, value2, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentAtNotBetween(Date value1, Date value2) {
            addCriterion("abandonment_at not between", value1, value2, "abandonmentAt");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdIsNull() {
            addCriterion("abandonment_id is null");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdIsNotNull() {
            addCriterion("abandonment_id is not null");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdEqualTo(String value) {
            addCriterion("abandonment_id =", value, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdNotEqualTo(String value) {
            addCriterion("abandonment_id <>", value, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdGreaterThan(String value) {
            addCriterion("abandonment_id >", value, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdGreaterThanOrEqualTo(String value) {
            addCriterion("abandonment_id >=", value, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdLessThan(String value) {
            addCriterion("abandonment_id <", value, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdLessThanOrEqualTo(String value) {
            addCriterion("abandonment_id <=", value, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdLike(String value) {
            addCriterion("abandonment_id like", value, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdNotLike(String value) {
            addCriterion("abandonment_id not like", value, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdIn(List<String> values) {
            addCriterion("abandonment_id in", values, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdNotIn(List<String> values) {
            addCriterion("abandonment_id not in", values, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdBetween(String value1, String value2) {
            addCriterion("abandonment_id between", value1, value2, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andAbandonmentIdNotBetween(String value1, String value2) {
            addCriterion("abandonment_id not between", value1, value2, "abandonmentId");
            return (Criteria) this;
        }

        public Criteria andNcidIsNull() {
            addCriterion("ncid is null");
            return (Criteria) this;
        }

        public Criteria andNcidIsNotNull() {
            addCriterion("ncid is not null");
            return (Criteria) this;
        }

        public Criteria andNcidEqualTo(String value) {
            addCriterion("ncid =", value, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidNotEqualTo(String value) {
            addCriterion("ncid <>", value, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidGreaterThan(String value) {
            addCriterion("ncid >", value, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidGreaterThanOrEqualTo(String value) {
            addCriterion("ncid >=", value, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidLessThan(String value) {
            addCriterion("ncid <", value, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidLessThanOrEqualTo(String value) {
            addCriterion("ncid <=", value, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidLike(String value) {
            addCriterion("ncid like", value, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidNotLike(String value) {
            addCriterion("ncid not like", value, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidIn(List<String> values) {
            addCriterion("ncid in", values, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidNotIn(List<String> values) {
            addCriterion("ncid not in", values, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidBetween(String value1, String value2) {
            addCriterion("ncid between", value1, value2, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcidNotBetween(String value1, String value2) {
            addCriterion("ncid not between", value1, value2, "ncid");
            return (Criteria) this;
        }

        public Criteria andNcCodeIsNull() {
            addCriterion("nc_code is null");
            return (Criteria) this;
        }

        public Criteria andNcCodeIsNotNull() {
            addCriterion("nc_code is not null");
            return (Criteria) this;
        }

        public Criteria andNcCodeEqualTo(String value) {
            addCriterion("nc_code =", value, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeNotEqualTo(String value) {
            addCriterion("nc_code <>", value, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeGreaterThan(String value) {
            addCriterion("nc_code >", value, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeGreaterThanOrEqualTo(String value) {
            addCriterion("nc_code >=", value, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeLessThan(String value) {
            addCriterion("nc_code <", value, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeLessThanOrEqualTo(String value) {
            addCriterion("nc_code <=", value, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeLike(String value) {
            addCriterion("nc_code like", value, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeNotLike(String value) {
            addCriterion("nc_code not like", value, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeIn(List<String> values) {
            addCriterion("nc_code in", values, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeNotIn(List<String> values) {
            addCriterion("nc_code not in", values, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeBetween(String value1, String value2) {
            addCriterion("nc_code between", value1, value2, "ncCode");
            return (Criteria) this;
        }

        public Criteria andNcCodeNotBetween(String value1, String value2) {
            addCriterion("nc_code not between", value1, value2, "ncCode");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}