package com.idea.paymentManagement.mapper;

import com.idea.customerManagement.dto.ContractManageDto;
import com.idea.paymentManagement.dto.PayLogDto;
import com.idea.paymentManagement.model.PayLog;
import com.idea.paymentManagement.model.PayLogExample;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface PayLogExtendMapper {

    String getMoneyByContractId(@Param("contractId") String contractId,
                                @Param("payType") Integer payType,
                                @Param("paymentStatus") Integer paymentStatus);

    PayLog getByContractId(@Param("contractId") String contractId,
                                @Param("payType") Integer payType,
                                @Param("paymentStatus") Integer paymentStatus);

    List<PayLogDto> getContentTypeMoneyByContractId(@Param("contractId") String contractId,
                                                    @Param("payType") Integer payType);

    List<ContractManageDto> listByModel(ContractManageDto contractManageDto);

    Integer countByGroupId(@Param("groupId") String groupId, @Param("contentType") String contentType);

    PayLog getByBusinessId(String businessId);

}