package com.idea.search.util;

public enum IndexTypeEnum {

    OP_LOG("OP_LOG", "操作日志"),
    FRAME_USER("FRAME_USER", "平台用户"),
    UNKNOWN("UNKNOWN", "未知索引");

    IndexTypeEnum(String code, String name) {
        this.code = code;
        this.name = name;
    }

    private String code;

    private String name;

    public static IndexTypeEnum getByCode(String code) {
        for (IndexTypeEnum typeEnum : IndexTypeEnum.values()) {
            if (typeEnum.code.equals(code)) {
                return typeEnum;
            }
        }
        return UNKNOWN;
    }

    public String getCode() {
        return code;
    }

    public String getName() {
        return name;
    }
}
